# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class EventModelV3(Model):
    """EventModelV3.

    All required parameters must be populated in order to send to Azure.

    :param id:
    :type id: str
    :param location_id:
    :type location_id: str
    :param window_id:
    :type window_id: str
    :param date_occurred: Required.
    :type date_occurred: datetime
    :param description:
    :type description: str
    :param reason:
    :type reason: str
    :param content_type: Required. Possible values include: 'Invalid',
     'OperationalCondition', 'Fault', 'RootCause', 'Evidence', 'Inspection',
     'PreventativeMaintenance', 'CorrectiveMaintenance', 'Observation',
     'Document', 'Description', 'SamplingFrequencyChange',
     'PendingSamplingFrequencyChange', 'AutoInvalidBurstData',
     'UserInvalidBurstData'
    :type content_type: str or ~smartdiagnostics_sdk.models.enum
    :param attachment: Required.
    :type attachment: ~smartdiagnostics_sdk.models.AttachmentModelV3
    :param code_ids:
    :type code_ids: list[str]
    :param tag_details:
    :type tag_details: list[str]
    :param document_url:
    :type document_url: str
    :param document_name:
    :type document_name: str
    :param title:
    :type title: str
    :param evidence_indicator_id:
    :type evidence_indicator_id: str
    :param created:
    :type created: datetime
    :param created_by:
    :type created_by: str
    :param modified:
    :type modified: datetime
    :param modified_by:
    :type modified_by: str
    :param savings:
    :type savings: float
    :param group_name:
    :type group_name: str
    :param group_path:
    :type group_path: str
    :param group_type: Possible values include: 'Invalid', 'Group', 'Asset',
     'MonitoringPoint', 'IndicatorGroup'
    :type group_type: str or ~smartdiagnostics_sdk.models.enum
    """

    _validation = {
        'date_occurred': {'required': True},
        'content_type': {'required': True},
        'attachment': {'required': True},
    }

    _attribute_map = {
        'id': {'key': 'Id', 'type': 'str'},
        'location_id': {'key': 'LocationId', 'type': 'str'},
        'window_id': {'key': 'WindowId', 'type': 'str'},
        'date_occurred': {'key': 'DateOccurred', 'type': 'iso-8601'},
        'description': {'key': 'Description', 'type': 'str'},
        'reason': {'key': 'Reason', 'type': 'str'},
        'content_type': {'key': 'ContentType', 'type': 'str'},
        'attachment': {'key': 'Attachment', 'type': 'AttachmentModelV3'},
        'code_ids': {'key': 'CodeIds', 'type': '[str]'},
        'tag_details': {'key': 'TagDetails', 'type': '[str]'},
        'document_url': {'key': 'DocumentUrl', 'type': 'str'},
        'document_name': {'key': 'DocumentName', 'type': 'str'},
        'title': {'key': 'Title', 'type': 'str'},
        'evidence_indicator_id': {'key': 'EvidenceIndicatorId', 'type': 'str'},
        'created': {'key': 'Created', 'type': 'iso-8601'},
        'created_by': {'key': 'CreatedBy', 'type': 'str'},
        'modified': {'key': 'Modified', 'type': 'iso-8601'},
        'modified_by': {'key': 'ModifiedBy', 'type': 'str'},
        'savings': {'key': 'Savings', 'type': 'float'},
        'group_name': {'key': 'GroupName', 'type': 'str'},
        'group_path': {'key': 'GroupPath', 'type': 'str'},
        'group_type': {'key': 'GroupType', 'type': 'str'},
    }

    def __init__(self, *, date_occurred, content_type, attachment, id: str=None, location_id: str=None, window_id: str=None, description: str=None, reason: str=None, code_ids=None, tag_details=None, document_url: str=None, document_name: str=None, title: str=None, evidence_indicator_id: str=None, created=None, created_by: str=None, modified=None, modified_by: str=None, savings: float=None, group_name: str=None, group_path: str=None, group_type=None, **kwargs) -> None:
        super(EventModelV3, self).__init__(**kwargs)
        self.id = id
        self.location_id = location_id
        self.window_id = window_id
        self.date_occurred = date_occurred
        self.description = description
        self.reason = reason
        self.content_type = content_type
        self.attachment = attachment
        self.code_ids = code_ids
        self.tag_details = tag_details
        self.document_url = document_url
        self.document_name = document_name
        self.title = title
        self.evidence_indicator_id = evidence_indicator_id
        self.created = created
        self.created_by = created_by
        self.modified = modified
        self.modified_by = modified_by
        self.savings = savings
        self.group_name = group_name
        self.group_path = group_path
        self.group_type = group_type
